#include <EEPROM.h>

byte income;
String tk, command, pin, val, s;
bool isAnalog;

void setup() {
   Serial.begin(9600); 
   Serial.println("Generic Atmega Board (Arduino Uno/Mega)");
}

void loop() {
  if (Serial.available()){
    income = Serial.read();
    tk = tk + (char)(income);
    if (income == 59){
      Serial.println(tk);
      Serial.println(readCommand(tk));
      tk = "";
    }
  }
}

int readCommand(String token){
   byte ret = -1;
   command = "";
   if ((token.length()>0) || (token.indexOf("(")>-1) || (token.indexOf(")")>-1)){
     pin = ""; 
     val= ""; 
     s = token.substring(token.indexOf("(")+1,token.indexOf(")"));
     if (s.indexOf(",")){
         pin = s.substring(0,s.indexOf(","));
         val = s.substring(s.indexOf(",")+1, s.length());
         if (val.indexOf("A")>-1){
            val = val.substring(1,val.length());
            val.trim();
            isAnalog = true;
         }
     }else{
          pin = s;
          val = "";
          isAnalog = false;
     }
     if (token.indexOf("pinMode")>-1){
        if ((val.indexOf("INPUT")>-1) || (val.indexOf("0")>-1)){
          pinMode(pin.toInt(),INPUT);
        }else if ((val.indexOf("OUTPUT")>-1) || (val.indexOf("1")>-1)){
          pinMode(pin.toInt(),OUTPUT);
        }
        command = "pinMode";
     }else if (token.indexOf("digitalRead")>-1){
        ret = digitalRead(pin.toInt());
        isAnalog = false; 
        command = "digitalRead";
     }else if (token.indexOf("analogRead")>-1){
        ret = analogRead(pin.toInt());
        isAnalog = true;
        command = "analogRead"; 
     }else if (token.indexOf("digitalWrite")>-1){
        digitalWrite(pin.toInt(),val.toInt()); Serial.println(pin.toInt());Serial.println(val.toInt()); 
        isAnalog = false;
        command = "digitalWrite";
        ret = digitalRead(pin.toInt());
     }else if (token.indexOf("analogWrite")>-1){
        analogWrite(pin.toInt(),val.toInt()); 
        isAnalog = false;
        command = "analogWrite";
        ret = analogRead(pin.toInt());
     }else{
        Serial.println(F("unknown command"));
        command = "unknown command";
        return -1;
     }
   }
   return ret;
}
